<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: vx_internal.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>vx_internal.h File Reference</h1><hr/><a name="_details"></a><h2>Introduction</h2>
<p>The top level TI OpenVX implementation header. </p>

<p><a href="vx__internal_8h_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga3ce34986ae4e8bb261f86e769fbbc167">TIVX_ALIGN</a>(value, align)&nbsp;&nbsp;&nbsp;((((value)+((align)-1))/(align))*(align))</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Macro to align a 'value' to 'align' units.  <a href="group__group__vx__utils.html#ga3ce34986ae4e8bb261f86e769fbbc167"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#gaa68f32003477b404904062d7786fc3bd">TIVX_FLOOR</a>(value, align)&nbsp;&nbsp;&nbsp;(((value)/(align))*(align))</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Macro to floor a 'value' to 'align' units.  <a href="group__group__vx__utils.html#gaa68f32003477b404904062d7786fc3bd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#gafed0fc37f24bfac4e4593ee9d3b87c8e">TIVX_DEFAULT_STRIDE_Y_ALIGN</a>&nbsp;&nbsp;&nbsp;(16U)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Macro to specify default alignment to use for stride in Y-direction.  <a href="group__group__vx__utils.html#gafed0fc37f24bfac4e4593ee9d3b87c8e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#gab4ba474b742b4fe12aed4cd4691bb6b9">TIVX_TYPE_IS_SCALAR</a>(type)&nbsp;&nbsp;&nbsp;((VX_TYPE_INVALID &lt; (type)) &amp;&amp; ((type) &lt; VX_TYPE_SCALAR_MAX))</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Used to determine if a type is a scalar.  <a href="group__group__vx__utils.html#gab4ba474b742b4fe12aed4cd4691bb6b9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga8046b2f6f99302f66e9e8153a230baf6">TIVX_TYPE_IS_STRUCT</a>(type)&nbsp;&nbsp;&nbsp;(((type) &gt;= VX_TYPE_RECTANGLE) &amp;&amp; ((type) &lt; VX_TYPE_KHRONOS_STRUCT_MAX))</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Used to determine if a type is a struct.  <a href="group__group__vx__utils.html#ga8046b2f6f99302f66e9e8153a230baf6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga93a451188d2830ed50d094120433500d">TIVX_TYPE_IS_OBJECT</a>(type)&nbsp;&nbsp;&nbsp;(((type) &gt;= VX_TYPE_REFERENCE) &amp;&amp; ((type) &lt; VX_TYPE_KHRONOS_OBJECT_END))</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Used to determine if a type is an object.  <a href="group__group__vx__utils.html#ga93a451188d2830ed50d094120433500d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga41ea76fbd9c3d52fa0dd25e3b0152b3e">TIVX_MAGIC</a>&nbsp;&nbsp;&nbsp;(0xFACEC0DEU)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A magic value to look for and set in references.  <a href="group__group__vx__utils.html#ga41ea76fbd9c3d52fa0dd25e3b0152b3e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga03c1805a3a7258cf0ec83ad8daab1838">TIVX_BAD_MAGIC</a>&nbsp;&nbsp;&nbsp;(42)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A magic value to look for and set in references. Used to indicate a free'ed reference.  <a href="group__group__vx__utils.html#ga03c1805a3a7258cf0ec83ad8daab1838"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga7986a750054beb62c0f9f720843e9495">VX_CHECK_PARAM</a>(ptr, size, type, align)&nbsp;&nbsp;&nbsp;((size == sizeof(type)) &amp;&amp; (((<a class="el" href="vx__types_8h.html#a46d89d47ad9a2de1de723d0db861d324">vx_size</a>)ptr &amp; align) == 0))</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A parameter checker for size and alignment.  <a href="group__group__vx__utils.html#ga7986a750054beb62c0f9f720843e9495"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga077bde7b4af50f959972477bba9569ef">dimof</a>(x)&nbsp;&nbsp;&nbsp;(sizeof(x)/sizeof(x[0]))</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Macro to find size of array.  <a href="group__group__vx__utils.html#ga077bde7b4af50f959972477bba9569ef"></a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga8e19e8244e8e40dac1af54ce04ac0b3a">tivxFlagIsBitSet</a> (uint32_t flag_var, uint32_t flag_val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Macro to check if flag is set, flag MUST be of bit type.  <a href="group__group__vx__utils.html#ga8e19e8244e8e40dac1af54ce04ac0b3a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#gabe1484e1cc6d183d574ff47720dba6f6">tivxFlagBitSet</a> (uint32_t *flag_var, uint32_t flag_val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Macro to set flag value, flag MUST be of bit type.  <a href="group__group__vx__utils.html#gabe1484e1cc6d183d574ff47720dba6f6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga534109d6c33d7c81285c09c9e1bd9892">tivxFlagBitClear</a> (uint32_t *flag_var, uint32_t flag_val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Macro to clear flag value, flag MUST be of bit type.  <a href="group__group__vx__utils.html#ga534109d6c33d7c81285c09c9e1bd9892"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga9bed7333f57423a1af3cc2c624016efa">tivx_uint32_to_uint64</a> (uint64_t *val, uint32_t h, uint32_t l)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Macro to convert 2x uint32 to uint64.  <a href="group__group__vx__utils.html#ga9bed7333f57423a1af3cc2c624016efa"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__utils.html#ga278ed34a28b05b22e15ee4a29b9a0935">tivx_uint64_to_uint32</a> (uint64_t val, uint32_t *h, uint32_t *l)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Macro to convert uint64 to 2x uint32.  <a href="group__group__vx__utils.html#ga278ed34a28b05b22e15ee4a29b9a0935"></a><br/></td></tr>
</table>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
